Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 3880)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 3881)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Bugfix in level 3 initialization of pavement albedo type and pavement 
+! emissivity
+! 
+! 3868 2019-04-08 11:52:36Z suehring
 ! More strict limitation of roughness length when it is in the order of the 
 ! vertical grid spacing 
@@ -4186,9 +4190,9 @@
                      pavement_pars_f%fill )                                    &
                    surf_lsm_h%albedo_type(ind_pav_green,m) =                   &
-                                              INT( pavement_pars(ind_p_at,st) )
+                                   INT( pavement_pars_f%pars_xy(ind_p_at,j,i) )
                 IF ( pavement_pars_f%pars_xy(ind_p_emis,j,i) /=                &
                      pavement_pars_f%fill )                                    &
                    surf_lsm_h%emissivity(ind_pav_green,m)  =                   &
-                                              pavement_pars(ind_p_emis,st) 
+                                   pavement_pars_f%pars_xy(ind_p_emis,j,i)
              ENDIF 
 
@@ -4246,10 +4250,10 @@
                         pavement_pars_f%fill )                                 &
                       surf_lsm_v(l)%albedo_type(ind_pav_green,m) =             &
-                                            INT( pavement_pars(ind_p_at,st) )
+                                   INT( pavement_pars_f%pars_xy(ind_p_at,j,i) )
 
                    IF ( pavement_pars_f%pars_xy(ind_p_emis,j,i) /=             &
                         pavement_pars_f%fill )                                 &
                       surf_lsm_v(l)%emissivity(ind_pav_green,m)  =             &
-                                            pavement_pars(ind_p_emis,st)  
+                                   pavement_pars_f%pars_xy(ind_p_emis,j,i)  
                 ENDIF 
              ENDDO
Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 3880)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 3881)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Bugfix in OpenMP directive
+! 
+! 3880 2019-04-08 21:43:02Z knoop
 ! Moved wtm_tendencies to module_interface_actions
 ! 
@@ -589,6 +592,5 @@
 !
 !-- Loop over all prognostic equations
-!-- b, c ang g added for SALSA
-    !$OMP PARALLEL PRIVATE (i,i_omp_start,j,k,loop_start,tn,b,c,g)
+    !$OMP PARALLEL PRIVATE (i,i_omp_start,j,k,loop_start,tn)
 
     !$  tn = omp_get_thread_num()
Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3880)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3881)
@@ -28,4 +28,8 @@
 ! -----------------
 ! $Id$
+! Output of albedo and emissivity moved from USM, bugfixes in initialization
+! of albedo
+! 
+! 3861 2019-04-04 06:27:41Z maronga
 ! Bugfix: factor of 4.0 required instead of 3.0 in calculation of rad_lw_out_change_0
 ! 
@@ -1397,5 +1401,6 @@
           unit = 'W/m2'
        ELSE IF ( var(1:7) == 'rtm_svf'  .OR.  var(1:7) == 'rtm_dif'  .OR.                &
-                 var(1:9) == 'rtm_skyvf' .OR. var(1:9) == 'rtm_skyvft' )  THEN
+                 var(1:9) == 'rtm_skyvf' .OR. var(1:9) == 'rtm_skyvft'  .OR.             &
+                 var(1:12) == 'rtm_surfalb_'  .OR.  var(1:13) == 'rtm_surfemis_'  ) THEN
           IF ( .NOT.  radiation ) THEN
                 message_string = 'output of "' // TRIM( var ) // '" require'&
@@ -2443,19 +2448,19 @@
                 DO  ind_type = 0, 2
                    IF ( surf_lsm_h%albedo_type(ind_type,m) == 0 )  THEN
-                      IF ( albedo_pars_f%pars_xy(1,j,i) /= albedo_pars_f%fill )&
+                      IF ( albedo_pars_f%pars_xy(0,j,i) /= albedo_pars_f%fill )&
                          surf_lsm_h%albedo(ind_type,m) =                       &
-                                                albedo_pars_f%pars_xy(1,j,i)
+                                                albedo_pars_f%pars_xy(0,j,i)
                       IF ( albedo_pars_f%pars_xy(1,j,i) /= albedo_pars_f%fill )&
                          surf_lsm_h%aldir(ind_type,m) =                        &
                                                 albedo_pars_f%pars_xy(1,j,i)
+                      IF ( albedo_pars_f%pars_xy(1,j,i) /= albedo_pars_f%fill )&
+                         surf_lsm_h%aldif(ind_type,m) =                        &
+                                                albedo_pars_f%pars_xy(1,j,i)
                       IF ( albedo_pars_f%pars_xy(2,j,i) /= albedo_pars_f%fill )&
-                         surf_lsm_h%aldif(ind_type,m) =                        &
+                         surf_lsm_h%asdir(ind_type,m) =                        &
                                                 albedo_pars_f%pars_xy(2,j,i)
-                      IF ( albedo_pars_f%pars_xy(3,j,i) /= albedo_pars_f%fill )&
-                         surf_lsm_h%asdir(ind_type,m) =                        &
-                                                albedo_pars_f%pars_xy(3,j,i)
-                      IF ( albedo_pars_f%pars_xy(4,j,i) /= albedo_pars_f%fill )&
+                      IF ( albedo_pars_f%pars_xy(2,j,i) /= albedo_pars_f%fill )&
                          surf_lsm_h%asdif(ind_type,m) =                        &
-                                                albedo_pars_f%pars_xy(4,j,i)
+                                                albedo_pars_f%pars_xy(2,j,i)
                    ENDIF
                 ENDDO
@@ -2469,24 +2474,54 @@
                    j = surf_usm_h%j(m)
 !
-!--                Spectral albedos for wall/green/window surfaces
+!--                Broadband albedos for wall/green/window surfaces
                    DO  ind_type = 0, 2
                       IF ( surf_usm_h%albedo_type(ind_type,m) == 0 )  THEN
-                         IF ( albedo_pars_f%pars_xy(1,j,i) /= albedo_pars_f%fill )&
+                         IF ( albedo_pars_f%pars_xy(0,j,i) /= albedo_pars_f%fill )&
                             surf_usm_h%albedo(ind_type,m) =                       &
-                                                albedo_pars_f%pars_xy(1,j,i)
-                         IF ( albedo_pars_f%pars_xy(1,j,i) /= albedo_pars_f%fill )&
-                            surf_usm_h%aldir(ind_type,m) =                        &
-                                                albedo_pars_f%pars_xy(1,j,i)
-                         IF ( albedo_pars_f%pars_xy(2,j,i) /= albedo_pars_f%fill )&
-                            surf_usm_h%aldif(ind_type,m) =                        &
-                                                albedo_pars_f%pars_xy(2,j,i)
-                         IF ( albedo_pars_f%pars_xy(3,j,i) /= albedo_pars_f%fill )&
-                            surf_usm_h%asdir(ind_type,m) =                        &
-                                                albedo_pars_f%pars_xy(3,j,i)
-                         IF ( albedo_pars_f%pars_xy(4,j,i) /= albedo_pars_f%fill )&
-                            surf_usm_h%asdif(ind_type,m) =                        &
-                                                albedo_pars_f%pars_xy(4,j,i)
+                                                albedo_pars_f%pars_xy(0,j,i)
                       ENDIF
                    ENDDO
+!
+!--                Spectral albedos especially for building wall surfaces
+                   IF ( albedo_pars_f%pars_xy(1,j,i) /= albedo_pars_f%fill )  THEN
+                      surf_usm_h%aldir(ind_veg_wall,m) =                       &
+                                                albedo_pars_f%pars_xy(1,j,i)
+                      surf_usm_h%aldif(ind_veg_wall,m) =                       &
+                                                albedo_pars_f%pars_xy(1,j,i)
+                   ENDIF
+                   IF ( albedo_pars_f%pars_xy(2,j,i) /= albedo_pars_f%fill )  THEN
+                      surf_usm_h%asdir(ind_veg_wall,m) =                       &
+                                                albedo_pars_f%pars_xy(2,j,i)
+                      surf_usm_h%asdif(ind_veg_wall,m) =                       &
+                                                albedo_pars_f%pars_xy(2,j,i)
+                   ENDIF
+!
+!--                Spectral albedos especially for building green surfaces
+                   IF ( albedo_pars_f%pars_xy(3,j,i) /= albedo_pars_f%fill )  THEN
+                      surf_usm_h%aldir(ind_pav_green,m) =                      &
+                                                albedo_pars_f%pars_xy(3,j,i)
+                      surf_usm_h%aldif(ind_pav_green,m) =                      &
+                                                albedo_pars_f%pars_xy(3,j,i)
+                   ENDIF
+                   IF ( albedo_pars_f%pars_xy(4,j,i) /= albedo_pars_f%fill )  THEN
+                      surf_usm_h%asdir(ind_pav_green,m) =                      &
+                                                albedo_pars_f%pars_xy(4,j,i)
+                      surf_usm_h%asdif(ind_pav_green,m) =                      &
+                                                albedo_pars_f%pars_xy(4,j,i)
+                   ENDIF
+!
+!--                Spectral albedos especially for building window surfaces
+                   IF ( albedo_pars_f%pars_xy(5,j,i) /= albedo_pars_f%fill )  THEN
+                      surf_usm_h%aldir(ind_wat_win,m) =                        &
+                                                albedo_pars_f%pars_xy(5,j,i)
+                      surf_usm_h%aldif(ind_wat_win,m) =                        &
+                                                albedo_pars_f%pars_xy(5,j,i)
+                   ENDIF
+                   IF ( albedo_pars_f%pars_xy(6,j,i) /= albedo_pars_f%fill )  THEN
+                      surf_usm_h%asdir(ind_wat_win,m) =                        &
+                                                albedo_pars_f%pars_xy(6,j,i)
+                      surf_usm_h%asdif(ind_wat_win,m) =                        &
+                                                albedo_pars_f%pars_xy(6,j,i)
+                   ENDIF
 
                 ENDDO
@@ -2505,24 +2540,24 @@
                    DO  ind_type = 0, 2
                       IF ( surf_lsm_v(l)%albedo_type(ind_type,m) == 0 )  THEN
-                         IF ( albedo_pars_f%pars_xy(1,j+joff,i+ioff) /=        &
+                         IF ( albedo_pars_f%pars_xy(0,j+joff,i+ioff) /=        &
                               albedo_pars_f%fill )                             &
                             surf_lsm_v(l)%albedo(ind_type,m) =                 &
-                                          albedo_pars_f%pars_xy(1,j+joff,i+ioff)
+                                          albedo_pars_f%pars_xy(0,j+joff,i+ioff)
                          IF ( albedo_pars_f%pars_xy(1,j+joff,i+ioff) /=        &
                               albedo_pars_f%fill )                             &
                             surf_lsm_v(l)%aldir(ind_type,m) =                  &
                                           albedo_pars_f%pars_xy(1,j+joff,i+ioff)
+                         IF ( albedo_pars_f%pars_xy(1,j+joff,i+ioff) /=        &
+                              albedo_pars_f%fill )                             &
+                            surf_lsm_v(l)%aldif(ind_type,m) =                  &
+                                          albedo_pars_f%pars_xy(1,j+joff,i+ioff)
                          IF ( albedo_pars_f%pars_xy(2,j+joff,i+ioff) /=        &
                               albedo_pars_f%fill )                             &
-                            surf_lsm_v(l)%aldif(ind_type,m) =                  &
+                            surf_lsm_v(l)%asdir(ind_type,m) =                  &
                                           albedo_pars_f%pars_xy(2,j+joff,i+ioff)
-                         IF ( albedo_pars_f%pars_xy(3,j+joff,i+ioff) /=        &
-                              albedo_pars_f%fill )                             &
-                            surf_lsm_v(l)%asdir(ind_type,m) =                  &
-                                          albedo_pars_f%pars_xy(3,j+joff,i+ioff)
-                         IF ( albedo_pars_f%pars_xy(4,j+joff,i+ioff) /=        &
+                         IF ( albedo_pars_f%pars_xy(2,j+joff,i+ioff) /=        &
                               albedo_pars_f%fill )                             &
                             surf_lsm_v(l)%asdif(ind_type,m) =                  &
-                                          albedo_pars_f%pars_xy(4,j+joff,i+ioff)
+                                          albedo_pars_f%pars_xy(2,j+joff,i+ioff)
                       ENDIF
                    ENDDO
@@ -2539,30 +2574,61 @@
                       j = surf_usm_v(l)%j(m)
 !
-!--                   Spectral albedos for wall/green/window surfaces
+!--                   Broadband albedos for wall/green/window surfaces
                       DO  ind_type = 0, 2
                          IF ( surf_usm_v(l)%albedo_type(ind_type,m) == 0 )  THEN
-                            IF ( albedo_pars_f%pars_xy(1,j+joff,i+ioff) /=        &
-                                 albedo_pars_f%fill )                             &
-                               surf_usm_v(l)%albedo(ind_type,m) =                 &
-                                             albedo_pars_f%pars_xy(1,j+joff,i+ioff)
-                            IF ( albedo_pars_f%pars_xy(1,j+joff,i+ioff) /=        &
-                                 albedo_pars_f%fill )                             &
-                               surf_usm_v(l)%aldir(ind_type,m) =                  &
-                                             albedo_pars_f%pars_xy(1,j+joff,i+ioff)
-                            IF ( albedo_pars_f%pars_xy(2,j+joff,i+ioff) /=        &
-                                 albedo_pars_f%fill )                             &
-                               surf_usm_v(l)%aldif(ind_type,m) =                  &
-                                             albedo_pars_f%pars_xy(2,j+joff,i+ioff)
-                            IF ( albedo_pars_f%pars_xy(3,j+joff,i+ioff) /=        &
-                                 albedo_pars_f%fill )                             &
-                               surf_usm_v(l)%asdir(ind_type,m) =                  &
-                                             albedo_pars_f%pars_xy(3,j+joff,i+ioff)
-                            IF ( albedo_pars_f%pars_xy(4,j+joff,i+ioff) /=        &
-                                 albedo_pars_f%fill )                             &
-                               surf_usm_v(l)%asdif(ind_type,m) =                  &
-                                             albedo_pars_f%pars_xy(4,j+joff,i+ioff)
+                            IF ( albedo_pars_f%pars_xy(0,j+joff,i+ioff) /=     &
+                                 albedo_pars_f%fill )                          &
+                               surf_usm_v(l)%albedo(ind_type,m) =              &
+                                             albedo_pars_f%pars_xy(0,j+joff,i+ioff)
                          ENDIF
                       ENDDO
-
+!
+!--                   Spectral albedos especially for building wall surfaces
+                      IF ( albedo_pars_f%pars_xy(1,j+joff,i+ioff) /=           &
+                           albedo_pars_f%fill )  THEN
+                         surf_usm_v(l)%aldir(ind_veg_wall,m) =                 &
+                                         albedo_pars_f%pars_xy(1,j+joff,i+ioff)
+                         surf_usm_v(l)%aldif(ind_veg_wall,m) =                 &
+                                         albedo_pars_f%pars_xy(1,j+joff,i+ioff)
+                      ENDIF
+                      IF ( albedo_pars_f%pars_xy(2,j+joff,i+ioff) /=           &
+                           albedo_pars_f%fill )  THEN
+                         surf_usm_v(l)%asdir(ind_veg_wall,m) =                 &
+                                         albedo_pars_f%pars_xy(2,j+joff,i+ioff)
+                         surf_usm_v(l)%asdif(ind_veg_wall,m) =                 &
+                                         albedo_pars_f%pars_xy(2,j+joff,i+ioff)
+                      ENDIF
+!                     
+!--                   Spectral albedos especially for building green surfaces
+                      IF ( albedo_pars_f%pars_xy(3,j+joff,i+ioff) /=           &
+                           albedo_pars_f%fill )  THEN
+                         surf_usm_v(l)%aldir(ind_pav_green,m) =                &
+                                         albedo_pars_f%pars_xy(3,j+joff,i+ioff)
+                         surf_usm_v(l)%aldif(ind_pav_green,m) =                &
+                                         albedo_pars_f%pars_xy(3,j+joff,i+ioff)
+                      ENDIF
+                      IF ( albedo_pars_f%pars_xy(4,j+joff,i+ioff) /=           &
+                           albedo_pars_f%fill )  THEN
+                         surf_usm_v(l)%asdir(ind_pav_green,m) =                &
+                                         albedo_pars_f%pars_xy(4,j+joff,i+ioff)
+                         surf_usm_v(l)%asdif(ind_pav_green,m) =                &
+                                         albedo_pars_f%pars_xy(4,j+joff,i+ioff)
+                      ENDIF
+!                     
+!--                   Spectral albedos especially for building window surfaces
+                      IF ( albedo_pars_f%pars_xy(5,j+joff,i+ioff) /=           &
+                           albedo_pars_f%fill )  THEN
+                         surf_usm_v(l)%aldir(ind_wat_win,m) =                  &
+                                         albedo_pars_f%pars_xy(5,j+joff,i+ioff)
+                         surf_usm_v(l)%aldif(ind_wat_win,m) =                  &
+                                         albedo_pars_f%pars_xy(5,j+joff,i+ioff)
+                      ENDIF
+                      IF ( albedo_pars_f%pars_xy(6,j+joff,i+ioff) /=           &
+                           albedo_pars_f%fill )  THEN
+                         surf_usm_v(l)%asdir(ind_wat_win,m) =                  &
+                                         albedo_pars_f%pars_xy(6,j+joff,i+ioff)
+                         surf_usm_v(l)%asdif(ind_wat_win,m) =                  &
+                                         albedo_pars_f%pars_xy(6,j+joff,i+ioff)
+                      ENDIF
                    ENDDO
                 ENDIF
@@ -9809,4 +9875,5 @@
          var(1:7) == 'rtm_svf'  .OR.  var(1:7) == 'rtm_dif'  .OR.                       &
          var(1:9) == 'rtm_skyvf' .OR. var(1:10) == 'rtm_skyvft'  .OR.                   &
+         var(1:12) == 'rtm_surfalb_'  .OR.  var(1:13) == 'rtm_surfemis_'  .OR.          &
          var == 'rtm_mrt'  .OR.  var ==  'rtm_mrt_sw'  .OR.  var == 'rtm_mrt_lw' )  THEN
 
@@ -10511,40 +10578,4 @@
          ENDIF
 
-!--   block of RTM output variables
-!--   variables are intended mainly for debugging and detailed analyse purposes
-      CASE ( 'rtm_skyvf' )
-!--        sky view factor
-         DO isurf = dirstart(ids), dirend(ids)
-            IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
-               local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = skyvf(isurf)
-            ENDIF
-         ENDDO
-
-      CASE ( 'rtm_skyvft' )
-!--      sky view factor
-         DO isurf = dirstart(ids), dirend(ids)
-            IF ( surfl(id,isurf) == ids )  THEN
-               local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = skyvft(isurf)
-            ENDIF
-         ENDDO
-
-      CASE ( 'rtm_svf', 'rtm_dif' )
-!--      shape view factors or iradiance factors to selected surface
-         IF ( TRIM(var)=='rtm_svf' )  THEN
-             k = 1
-         ELSE
-             k = 2
-         ENDIF
-         DO isvf = 1, nsvfl
-            isurflt = svfsurf(1, isvf)
-            isurfs = svfsurf(2, isvf)
-
-            IF ( surf(ix,isurfs) == is  .AND.  surf(iy,isurfs) == js  .AND. surf(iz,isurfs) == ks  .AND. &
-                 (surf(id,isurfs) == idsint_u .OR. surfl(id,isurfs) == idsint_l ) ) THEN
-!--            correct source surface
-               local_pf(surfl(ix,isurflt),surfl(iy,isurflt),surfl(iz,isurflt)) = svf(k,isvf)
-            ENDIF
-         ENDDO
-
       CASE ( 'rtm_rad_net' )
 !--     array of complete radiation balance
@@ -10785,7 +10816,65 @@
             ENDIF
          ENDIF
-
-       CASE DEFAULT
-          found = .FALSE.
+!         
+!--   block of RTM output variables
+!--   variables are intended mainly for debugging and detailed analyse purposes
+      CASE ( 'rtm_skyvf' )
+!      
+!--      sky view factor
+         DO isurf = dirstart(ids), dirend(ids)
+            IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+               local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = skyvf(isurf)
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_skyvft' )
+!
+!--      sky view factor
+         DO isurf = dirstart(ids), dirend(ids)
+            IF ( surfl(id,isurf) == ids )  THEN
+               local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = skyvft(isurf)
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_svf', 'rtm_dif' )
+!
+!--      shape view factors or iradiance factors to selected surface
+         IF ( TRIM(var)=='rtm_svf' )  THEN
+             k = 1
+         ELSE
+             k = 2
+         ENDIF
+         DO isvf = 1, nsvfl
+            isurflt = svfsurf(1, isvf)
+            isurfs = svfsurf(2, isvf)
+
+            IF ( surf(ix,isurfs) == is  .AND.  surf(iy,isurfs) == js  .AND. surf(iz,isurfs) == ks  .AND. &
+                 (surf(id,isurfs) == idsint_u .OR. surfl(id,isurfs) == idsint_l ) ) THEN
+!
+!--            correct source surface
+               local_pf(surfl(ix,isurflt),surfl(iy,isurflt),surfl(iz,isurflt)) = svf(k,isvf)
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_surfalb' )
+!
+!--      surface albedo
+         DO isurf = dirstart(ids), dirend(ids)
+            IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+               local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = albedo_surf(isurf)
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_surfemis' )
+!
+!--      surface emissivity, weighted average
+         DO isurf = dirstart(ids), dirend(ids)
+            IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+               local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = emiss_surf(isurf)
+            ENDIF
+         ENDDO
+
+      CASE DEFAULT
+         found = .FALSE.
 
     END SELECT
Index: palm/trunk/SOURCE/surface_data_output_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 3880)
+++ palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 3881)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Check for zero output timestep (not allowed in parallel NetCDF output mode) 
+! 
+! 3817 2019-03-26 13:53:57Z suehring
 ! Correct output coordinates of vertical surface elements
 ! 
@@ -125,5 +128,6 @@
    USE netcdf_interface,                                                       &
        ONLY:  netcdf_create_att, netcdf_create_dim, netcdf_create_file,        &
-              netcdf_create_global_atts, netcdf_create_var, netcdf_handle_error
+              netcdf_create_global_atts, netcdf_create_var, netcdf_data_format,&
+              netcdf_handle_error
 
    USE pegrid
@@ -4316,4 +4320,26 @@
 #endif
 !
+!--    In case of parallel NetCDF output the output timestep must not be zero.
+!--    This is because the number of requiered output timesteps is 
+!--    pre-calculated, which is not possible with zero output timestep. 
+       IF ( netcdf_data_format > 4 )  THEN
+          IF ( dt_dosurf == 0.0_wp )  THEN
+             message_string = 'dt_dosurf = 0.0 while using a ' //             &
+                              'variable timestep and parallel netCDF4 ' //    &
+                              'is not allowed.'
+             CALL message( 'surface_data_output_check_parameters', 'PA0081',  &
+                           1, 2, 0, 6, 0 )
+          ENDIF
+          
+          IF ( dt_dosurf_av == 0.0_wp )  THEN
+             message_string = 'dt_dosurf_av = 0.0 while using a ' //          &
+                              'variable timestep and parallel netCDF4 ' //    &
+                              'is not allowed.'
+             CALL message( 'surface_data_output_check_parameters', 'PA0081',  &
+                           1, 2, 0, 6, 0 )
+          ENDIF
+       ENDIF
+
+!
 !--   In case of restart runs, check it the number of cores has been changed.
 !--   With surface output this is not allowed.
Index: palm/trunk/SOURCE/surface_layer_fluxes_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 3880)
+++ palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 3881)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Assure that Obukhov length does not become zero
+! 
+! 3834 2019-03-28 15:40:15Z forkel
 ! added USE chem_gasphase_mod 
 ! 
@@ -1188,4 +1191,8 @@
                 CYCLE
              ENDIF
+!
+!--          Assure that Obukhov length does not become zero
+             IF ( ABS( surf%ol(m) ) < 1E-6_wp )                                &
+                surf%ol(m) = SIGN( 10E-6_wp, surf%ol(m) )              
 
           ENDDO
